unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, api;

type
  TMainForm = class(TForm)
    StartButton: TButton;
    Memo: TMemo;
    procedure StartButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.StartButtonClick(Sender: TObject);
var out_buf: array of PROCESSOR_POWER_INFORMATION;
    er: Cardinal;
    si: _SYSTEM_INFO;
    numPr: Cardinal;
    I: Integer;
    bs: SYSTEM_BATTERY_STATE;
begin
  Memo.Lines.Clear;
  GetSystemInfo(si);
  numPr := si.dwNumberOfProcessors;
  SetLength(out_buf,numPr);
  er:=CallNtPowerInformation(11,Nil,0,
    out_buf,SizeOf(PROCESSOR_POWER_INFORMATION)*numPr);
  if er = 0 then
  begin
    for I := 0 to numPr - 1 do
    begin
      Memo.Lines.Add(IntToStr(out_buf[I].MhzLimit)+' MHz');
    end;
  end;
  out_buf:= Nil;
  //========
  er:=CallNtPowerInformation(5,Nil,0,
    @bs, SizeOf(SYSTEM_BATTERY_STATE));
  if er = 0 then
  begin
    Memo.Lines.Add(IntToStr(bs.RemainingCapacity)+' mWh');
  end;

end;

end.
